<?php
ini_set( 'display_errors', 1 ); 

$keyNumber = 452431;
$name = (isset($_GET['name']) ? $_GET['name'] : '');
$name = urldecode(str_replace('\\x', '%', $name)); // decode

$score = (int) (isset($_GET['score']) ? $_GET['score'] : -1);
$key = (int) (isset($_GET['key']) ? $_GET['key'] : -1);


// open
if (! $db = new PDO('sqlite:./rank.db') ) {
	print('DB connection failed');
	return;
}
// table check
$sql = 'select count(*) cnt from sqlite_master where type=\'table\' and name=\'ranking\'';
$ret = $db->query($sql);
$row = $ret->fetch(PDO::FETCH_ASSOC);

if ($row['cnt'] == 0) {
	$sql = 'create table ranking (rank int, name text, score int, update_time datetime DEFAULT (DATETIME(\'now\',\'localtime\')))';
	$db->exec($sql);
}

// if valid data is provided
if (!empty($name) && ($score & $keyNumber) == $key) {

	$stmt = $db->prepare('select count(*) cnt from ranking where score >= :score');
	$stmt->bindParam(':score', $score);
	$stmt->execute();

	$row = $stmt->fetch(PDO::FETCH_ASSOC);
	$rank = $row['cnt'] + 1;


	// transaction
 	//トランザクションの開始
 	$db->beginTransaction();

 	try {
 		// update
		$stmt = $db->prepare('update ranking set rank = rank + 1 where rank >= :rank');
		$stmt->bindParam(':rank', $rank);
		$stmt->execute();
		// insert
		$stmt = $db->prepare('insert into ranking (rank, name, score) values (:rank, :name, :score)');
		$stmt->bindParam(':rank', $rank);
		$stmt->bindParam(':name', $name);
		$stmt->bindParam(':score', $score);
		if(!$stmt->execute()){
			print('eror...');
			$db->rollBack();
		}

		$db->commit();
 	} catch (Exception $e) {
 		$db->rollBack();
 	}

	$stmt = $db->prepare('select * from ranking where rank >= :rank order by rank limit 14');
	$rank -= 5;

	$stmt->bindParam(':rank', $rank);
	$stmt->execute();

	$data = $stmt->fetchAll();

} else {

	$ret = $db->query('select * from ranking order by rank limit 14');
	$data = $ret->fetchAll();

}

// display ranking
$format = "[%3d] %-16.16s %5d %s\n";
foreach ($data as $row) {
	print(sprintf($format, $row['rank'], $row['name'], $row['score'], $row['update_time']));
}

// close
$db = null;

?>